import { getTabstopsRecord, replaceBody, replaceCustomVar, replaceTabstops } from "./replace";
import { mergeSnippet } from "./utils";
export * from "./types";
export default function defineSnippet(config, snippets) {
  const bodyRecord = mergeSnippet(snippets);
  const newSnippet = Object.entries(config).reduce((newSnippet, [snippetName, snippetItem]) => {
    var _snippetItem$extra;

    let tabstopsRecord;

    if ((_snippetItem$extra = snippetItem.extra) !== null && _snippetItem$extra !== void 0 && _snippetItem$extra.tabstops) {
      var _snippetItem$extra2;

      tabstopsRecord = getTabstopsRecord((_snippetItem$extra2 = snippetItem.extra) === null || _snippetItem$extra2 === void 0 ? void 0 : _snippetItem$extra2.tabstops);
    }

    const newBodyRecord = Object.entries(bodyRecord).reduce((bodyRecord, [snippetName, body]) => {
      bodyRecord[snippetName] = body.map(code => replaceTabstops(code, snippetName, {
        tabstopsRecord
      }));
      return bodyRecord;
    }, {});
    let body = snippetItem.body.map(code => replaceBody(code, {
      bodyRecord: newBodyRecord
    }));
    body = body.map(code => {
      var _snippetItem$extra3;

      return replaceCustomVar(code, {
        customVarRecord: (_snippetItem$extra3 = snippetItem.extra) === null || _snippetItem$extra3 === void 0 ? void 0 : _snippetItem$extra3.customVar
      });
    });
    const newSnippetItem = {
      prefix: snippetItem.prefix,
      scope: snippetItem.scope,
      description: snippetItem.description,
      body
    };
    newSnippet[snippetName] = newSnippetItem;
    return newSnippet;
  }, {});
  return newSnippet;
}